<?php
/** 
*
* @package phpBB3 ZFX Mod
* @version $Id: frontpage.php 1 2009-03-16 20:40:05Z CodingCat $
* @copyright (c) 2009 ZFX Community
* @license http://opensource.org/licenses/gpl-license.php GNU Public License
*
*/

// Customization
$news_forum_id = 6;
$news_max_entries = 3;
$news_max_length = 200;

$topics_forum_ids = array(5, 4, 7, 18, 10, 9);
$topics_columns = 3;
$topics_max_entries = 3;
$topics_max_length = 100;

// The default phpBB inclusion protection - required
define('IN_PHPBB', true);
$phpbb_root_path = './';
$phpEx = substr(strrchr(__FILE__, '.'), 1);


include($phpbb_root_path . 'common.' . $phpEx);
include($phpbb_root_path . 'includes/functions_display.' . $phpEx);
include($phpbb_root_path . 'includes/bbcode.' . $phpEx);

// Start session management
$user->session_begin();
$auth->acl($user->data);

// Langugae setup
$user->setup(array('viewforum', 'mods/frontpage'));


// Grab all post data
$news_rowset = $news_post_list = array();

$sql_array = array(
	'SELECT'	=> 'p.*, t.topic_replies, t.topic_replies_real, u.username, u.user_colour',
	'FROM'		=> array(
		POSTS_TABLE		=> 'p',
		TOPICS_TABLE	=> 't',
		USERS_TABLE		=> 'u'
	),
	'LEFT_JOIN'	=> array(),
);

$sql_where = 't.forum_id = ' . $news_forum_id . ' AND t.topic_status <> ' . ITEM_MOVED;
$sql_approved = ($auth->acl_get('m_approve', $news_forum_id)) ? '' : 'AND t.topic_approved = 1';
$sql_sort_order = 't.topic_time DESC';
$sql_limit = $news_max_entries;
$sql_start = 0;

// Grab just the sorted post ids
$sql = 'SELECT t.topic_first_post_id
	FROM ' . TOPICS_TABLE . " t
	WHERE $sql_where
		$sql_approved
	ORDER BY $sql_sort_order";
$result = $db->sql_query_limit($sql, $sql_limit, $sql_start);

while ($row = $db->sql_fetchrow($result))
{
	$news_post_list[] = (int) $row['topic_first_post_id'];
}
$db->sql_freeresult($result);

if (sizeof($news_post_list))
{
	// SQL array for obtaining posts
	$sql_array = array(
		'SELECT'		=> $sql_array['SELECT'],
		'FROM'			=> $sql_array['FROM'],
		'LEFT_JOIN'		=> $sql_array['LEFT_JOIN'],

		'WHERE'			=> $db->sql_in_set('p.post_id', $news_post_list) . ' AND p.topic_id = t.topic_id AND p.poster_id = u.user_id',
	);

	$sql = $db->sql_build_query('SELECT', $sql_array);
	$result = $db->sql_query($sql);

	while ($row = $db->sql_fetchrow($result))
	{
		$news_rowset[$row['post_id']] = $row;
	}
	$db->sql_freeresult($result);
}

unset($sql_array);


// Grab icons
$icons = $cache->obtain_icons();

// Grab all topic data
$topics_rowset = $topics_list = array();

$sql_array = array(
	'SELECT'	=> 't.*, f.forum_name, f.enable_icons',
	'FROM'		=> array(
		TOPICS_TABLE	=> 't',
		FORUMS_TABLE	=> 'f',
	),
	'LEFT_JOIN'	=> array(),
);

if (sizeof($topics_forum_ids))
{
	foreach ($topics_forum_ids as $forum_id)
	{
		$sql_where = 't.forum_id = ' . $forum_id . ' AND t.topic_status <> ' . ITEM_MOVED;
		$sql_approved = ($auth->acl_get('m_approve', $forum_id)) ? '' : 'AND t.topic_approved = 1';
		$sql_sort_order = 't.topic_last_post_time DESC';
		$sql_limit = $topics_max_entries;
		$sql_start = 0;

		// Grab just the sorted post ids
		$sql = 'SELECT t.topic_id
			FROM ' . TOPICS_TABLE . " t
			WHERE $sql_where
				$sql_approved
			ORDER BY $sql_sort_order";
		$result = $db->sql_query_limit($sql, $sql_limit, $sql_start);

		while ($row = $db->sql_fetchrow($result))
		{
			$topics_list[] = (int) $row['topic_id'];
		}
		$db->sql_freeresult($result);
	}
	
	if (sizeof($topics_list))
	{
		// SQL array for obtaining posts
		$sql_array = array(
			'SELECT'		=> $sql_array['SELECT'],
			'FROM'			=> $sql_array['FROM'],
			'LEFT_JOIN'		=> $sql_array['LEFT_JOIN'],

			'WHERE'			=> $db->sql_in_set('t.topic_id', $topics_list) . ' AND t.forum_id = f.forum_id',
		);

		$sql = $db->sql_build_query('SELECT', $sql_array);
		$result = $db->sql_query($sql);

		while ($row = $db->sql_fetchrow($result))
		{		
			$topics_rowset[(int) $row['topic_id']] = $row;
		}
		$db->sql_freeresult($result);
	}
}


// Output the page
page_header($user->lang['WELCOME']);

// Okay, lets dump out the page ...
if (sizeof($news_post_list))
{
	foreach ($news_post_list as $post_id)
	{
		$row = &$news_rowset[$post_id];
		
		$topic_id = $row['topic_id'];
		
		$message = censor_text($row['post_text']);
		strip_bbcode($message, $row['bbcode_uid']);
		$message = truncate_string($message, $news_max_length, 64 * $news_max_length, true, "...");
		
		// Replies
		$replies = $auth->acl_get('m_approve', $news_forum_id) ? $row['topic_replies_real'] : $row['topic_replies'];
		
		// Send vars to template
		$template->assign_block_vars('newsentry', array(
			'FORUM_ID'				=> $news_forum_id,
			'TOPIC_ID'				=> $topic_id,
			'POST_ID'				=> $post_id,
			
			'POST_AUTHOR_FULL'		=> get_username_string('full', $row['poster_id'], $row['username'], $row['user_colour']),
			'POST_AUTHOR_COLOUR'	=> get_username_string('colour', $row['poster_id'], $row['username'], $row['user_colour']),
			'POST_AUTHOR'			=> get_username_string('username', $row['poster_id'], $row['username'], $row['user_colour']),
			'U_POST_AUTHOR'			=> get_username_string('profile', $row['poster_id'], $row['username'], $row['user_colour']),
			
			'POST_SUBJECT'			=> censor_text($row['post_subject']),
			'POST_DATE'				=> (!empty($row['post_time'])) ? $user->format_date($row['post_time']) : '',
			
			'POST_TEXT'				=> $message,
			'TOPIC_REPLIES'			=> $row['topic_replies'],
			
			'U_VIEW_FORUM'			=> append_sid("{$phpbb_root_path}viewforum.$phpEx", "f=$news_forum_id"),
			'U_VIEW_TOPIC'			=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f=$news_forum_id&amp;t=topic_id"),
			'U_VIEW_POST'			=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f=$news_forum_id&amp;t=topic_id&amp;p=$post_id#p$post_id")
			)
		);

		unset($news_rowset[$post_id]);
	}
}


// Output recent posts
if (sizeof($topics_list))
{
	$s_forum_id_switch = -1;
	$s_forum_switches = -1;

	foreach ($topics_list as $topic_id)
	{
		$row = &$topics_rowset[$topic_id];
		
		$forum_id = $row['forum_id'];
		$post_id = $row['topic_last_post_id'];
		
		$title = censor_text($row['topic_title']);
		$title = truncate_string($title, $topics_max_length, 64 * $topics_max_length, true, "...");
		
		$subject = censor_text($row['topic_last_post_subject']);
		$subject = truncate_string($subject, $topics_max_length, 64 * $topics_max_length, true, "...");
		
		// Replies
		$replies = $auth->acl_get('m_approve', $forum_id) ? $row['topic_replies_real'] : $row['topic_replies'];
		
		// Get folder img, topic status/type related information
		$folder_img = $folder_alt = $topic_type = '';
		topic_status($row, $replies, true, $folder_img, $folder_alt, $topic_type);
		
		$s_forum_switches += ($s_forum_id_switch == $forum_id) ? 0 : 1;
		
		// Send vars to template
		$template->assign_block_vars('topicrow', array(
			'FORUM_ID'					=> $forum_id,
			'TOPIC_ID'					=> $topic_id,
			'POST_ID'					=> $post_id,
			
			'FORUM_NAME'				=> $row['forum_name'],
			
			'POST_AUTHOR_FULL'			=> get_username_string('full', $row['topic_last_poster_id'], $row['topic_last_poster_name'], $row['topic_last_poster_colour']),
			'POST_AUTHOR_COLOUR'		=> get_username_string('colour', $row['topic_last_poster_id'], $row['topic_last_poster_name'], $row['topic_last_poster_colour']),
			'POST_AUTHOR'				=> get_username_string('username', $row['topic_last_poster_id'], $row['topic_last_poster_name'], $row['topic_last_poster_colour']),
			'U_POST_AUTHOR'				=> get_username_string('profile', $row['topic_last_poster_id'], $row['topic_last_poster_name'], $row['topic_last_poster_colour']),
			
			'POST_SUBJECT'				=> $subject,
			'POST_DATE'					=> (!empty($row['topic_last_post_time'])) ? $user->format_date($row['topic_last_post_time']) : '',
			
			'REPLIES'					=> $replies,
			'VIEWS'						=> $row['topic_views'],
			'TOPIC_TITLE'				=> $title,
			'TOPIC_TYPE'				=> $topic_type,
			
			'U_VIEW_FORUM'				=> append_sid("{$phpbb_root_path}viewforum.$phpEx", "f=$forum_id"),
			'U_VIEW_TOPIC'				=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f=$forum_id&amp;t=topic_id"),
			'U_VIEW_POST'				=> append_sid("{$phpbb_root_path}viewtopic.$phpEx", "f=$forum_id&amp;t=topic_id&amp;p=$post_id#p$post_id"),
			
			'TOPIC_FOLDER_IMG'			=> $user->img($folder_img, $folder_alt),
			'TOPIC_FOLDER_IMG_SRC'		=> $user->img($folder_img, $folder_alt, false, '', 'src'),
			'TOPIC_FOLDER_IMG_ALT'		=> $user->lang[$folder_alt],
			'TOPIC_FOLDER_IMG_WIDTH'	=> $user->img($folder_img, '', false, '', 'width'),
			'TOPIC_FOLDER_IMG_HEIGHT'	=> $user->img($folder_img, '', false, '', 'height'),

			'TOPIC_ICON_IMG'			=> (!empty($icons[$row['icon_id']])) ? $icons[$row['icon_id']]['img'] : '',
			'TOPIC_ICON_IMG_WIDTH'		=> (!empty($icons[$row['icon_id']])) ? $icons[$row['icon_id']]['width'] : '',
			'TOPIC_ICON_IMG_HEIGHT'		=> (!empty($icons[$row['icon_id']])) ? $icons[$row['icon_id']]['height'] : '',
			'ATTACH_ICON_IMG'			=> ($auth->acl_get('u_download') && $auth->acl_get('f_download', $forum_id) && $row['topic_attachment']) ? $user->img('icon_topic_attach', $user->lang['TOTAL_ATTACHMENTS']) : '',
			
			'S_TOPIC_ICONS'				=> ($row['enable_icons']) ? true : false,
			
			'S_TOPIC_TYPE'				=> $row['topic_type'],
			'S_TOPIC_REPORTED'			=> (!empty($row['topic_reported']) && $auth->acl_get('m_report', $forum_id)) ? true : false,
			'S_HAS_POLL'				=> ($row['poll_start']) ? true : false,
			'S_POST_ANNOUNCE'			=> ($row['topic_type'] == POST_ANNOUNCE) ? true : false,
			'S_POST_GLOBAL'				=> ($row['topic_type'] == POST_GLOBAL) ? true : false,
			'S_POST_STICKY'				=> ($row['topic_type'] == POST_STICKY) ? true : false,
			'S_TOPIC_LOCKED'			=> ($row['topic_status'] == ITEM_LOCKED) ? true : false,
			
			'S_FORUM_ID_SWITCH'			=> ($s_forum_id_switch == $forum_id) ? -1 : $forum_id,
			'S_FORUM_SWITCHES'			=> $s_forum_switches
			)
		);
		
		$s_forum_id_switch = $forum_id;

		unset($topics_rowset[$topic_id]);
	}
}

$template->assign_vars(array(
	'U_MCP'				=> ($auth->acl_get('m_', $news_forum_id)) ? append_sid("{$phpbb_root_path}mcp.$phpEx", "f=$news_forum_id&amp;i=main&amp;mode=forum_view", true, $user->session_id) : '',
	'U_NEWS' 			=> append_sid("{$phpbb_root_path}viewforum.$phpEx", 'f=' . $news_forum_id),
	
	'S_TOPICS_COLUMNS'	=> $topics_columns
	)
);

$template->set_filenames(array(
	'body' => 'frontpage.html')
);

make_jumpbox(append_sid("{$phpbb_root_path}viewforum.$phpEx"));

page_footer();

?>